package be.iminds.ilabt.jfed.ui.cli2.instruction;

import be.iminds.ilabt.jfed.experiment.setup.config.Slice;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.List;

public class SshInstruction extends InstructionWithSlice {
    private final boolean showCommand;
    private final String nodeClientId; //if null, logs in to node if there is only 1, fails otherwise

    @JsonCreator
    public SshInstruction(@JsonProperty("action") @Nonnull Action action,
                          @JsonProperty("user") @Nullable User user,
                          @JsonProperty("actionOutputs") @Nullable List<ActionOutput> actionOutputs,
                          @JsonProperty("debugOutputs") @Nullable List<DebugOutput> debugOutputs,
                          @JsonProperty("callOutputs") @Nullable List<CallOutput> callOutputs,
                          @JsonProperty("proxy") @Nullable ProxySettings proxy,
                          @JsonProperty("slice") Slice slice,
                          @JsonProperty("showCommand") @Nullable Boolean showCommand,
                          @JsonProperty("nodeClientId") @Nullable String nodeClientId) {
        super(action, user, actionOutputs, debugOutputs, callOutputs, proxy, slice);
        this.showCommand = showCommand == null ? false : showCommand;
        this.nodeClientId = nodeClientId;
    }

    private SshInstruction(boolean demo) {
        super(Action.LOGIN, demo, true);
        this.showCommand = true;
        this.nodeClientId = "node0";
    }

    @JsonProperty("showCommand")
    public boolean isShowCommand() {
        return showCommand;
    }

    @JsonProperty
    public String getNodeClientId() {
        return nodeClientId;
    }

    @JsonIgnore
    @Nonnull
    @Override
    public Action getActionOfClass() {
        return Action.LOGIN;
    }
}
