package be.iminds.ilabt.jfed.highlevel.util;

import be.iminds.ilabt.jfed.call_log_output.LogOutput;

import javax.annotation.Nonnull;

/**
 * LogEntryListener: listens to new LogOutput.LogEntry
 */
public interface LogEntryListener {
    default void error(String message, Throwable e) {
        log(message, LogOutput.LogLineType.ERROR, e);
    }
    default void error(String message) {
        error(message, null);
    }
    default void warn(String message, Throwable e) {
        log(message, LogOutput.LogLineType.WARN, e);
    }
    default void warn(String message) {
        warn(message, null);
    }
    default void info(String message, Throwable e) {
        log(message, LogOutput.LogLineType.NOTE, e);
    }
    default void info(String message) {
        info(message, null);
    }
    default void debug(String message, Throwable e) {
        log(message, LogOutput.LogLineType.DEBUG, e);
    }
    default void debug(String message) {
        debug(message, null);
    }
    default void log(String message, LogOutput.LogLineType logLineType) {
        this.log(message, logLineType, null);
    }
    default void log(String message, LogOutput.LogLineType logLineType, Throwable e) {
        assert logLineType != null;
        assert message != null;
        log(new LogOutput.LogEntry(logLineType, message, e));
    }

    void log(@Nonnull LogOutput.LogEntry logEntry);
}
